"""
    IRN API v1

    Allows users to extract, create, update and configure IRN data.  # noqa: E501

    The version of the OpenAPI document: 1
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.IRNContacts.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.IRNContacts.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.IRNContacts.model.alternative_email_address_dto import AlternativeEmailAddressDto
    from fds.sdk.IRNContacts.model.contact_address_dto import ContactAddressDto
    from fds.sdk.IRNContacts.model.contact_custom_field_value_save_dto import ContactCustomFieldValueSaveDto
    from fds.sdk.IRNContacts.model.contact_phone_save_dto import ContactPhoneSaveDto
    from fds.sdk.IRNContacts.model.contact_relationship_save_dto import ContactRelationshipSaveDto
    globals()['AlternativeEmailAddressDto'] = AlternativeEmailAddressDto
    globals()['ContactAddressDto'] = ContactAddressDto
    globals()['ContactCustomFieldValueSaveDto'] = ContactCustomFieldValueSaveDto
    globals()['ContactPhoneSaveDto'] = ContactPhoneSaveDto
    globals()['ContactRelationshipSaveDto'] = ContactRelationshipSaveDto


class ContactSaveDto(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('primary_email_address',): {
            'max_length': 255,
            'min_length': 0,
        },
        ('full_name',): {
            'max_length': 255,
            'min_length': 0,
        },
        ('linked_in_profile',): {
            'max_length': 255,
            'min_length': 0,
        },
        ('person_symbol',): {
            'max_length': 255,
            'min_length': 0,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'primary_email_address': (str, none_type,),  # noqa: E501
            'full_name': (str, none_type,),  # noqa: E501
            'notes': (str, none_type,),  # noqa: E501
            'linked_in_profile': (str, none_type,),  # noqa: E501
            'person_symbol': (str, none_type,),  # noqa: E501
            'role_id': (str,),  # noqa: E501
            'type_id': (str,),  # noqa: E501
            'address': (ContactAddressDto,),  # noqa: E501
            'phone_numbers': ([ContactPhoneSaveDto], none_type,),  # noqa: E501
            'left_relationships': ([ContactRelationshipSaveDto], none_type,),  # noqa: E501
            'right_relationships': ([ContactRelationshipSaveDto], none_type,),  # noqa: E501
            'alternative_email_addresses': ([AlternativeEmailAddressDto], none_type,),  # noqa: E501
            'custom_fields': ([ContactCustomFieldValueSaveDto], none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'primary_email_address': 'PrimaryEmailAddress',  # noqa: E501
        'full_name': 'FullName',  # noqa: E501
        'notes': 'Notes',  # noqa: E501
        'linked_in_profile': 'LinkedInProfile',  # noqa: E501
        'person_symbol': 'PersonSymbol',  # noqa: E501
        'role_id': 'RoleId',  # noqa: E501
        'type_id': 'TypeId',  # noqa: E501
        'address': 'Address',  # noqa: E501
        'phone_numbers': 'PhoneNumbers',  # noqa: E501
        'left_relationships': 'LeftRelationships',  # noqa: E501
        'right_relationships': 'RightRelationships',  # noqa: E501
        'alternative_email_addresses': 'AlternativeEmailAddresses',  # noqa: E501
        'custom_fields': 'CustomFields',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """ContactSaveDto - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            primary_email_address (str, none_type): [optional]  # noqa: E501
            full_name (str, none_type): [optional]  # noqa: E501
            notes (str, none_type): [optional]  # noqa: E501
            linked_in_profile (str, none_type): [optional]  # noqa: E501
            person_symbol (str, none_type): [optional]  # noqa: E501
            role_id (str): [optional]  # noqa: E501
            type_id (str): [optional]  # noqa: E501
            address (ContactAddressDto): [optional]  # noqa: E501
            phone_numbers ([ContactPhoneSaveDto], none_type): [optional]  # noqa: E501
            left_relationships ([ContactRelationshipSaveDto], none_type): [optional]  # noqa: E501
            right_relationships ([ContactRelationshipSaveDto], none_type): [optional]  # noqa: E501
            alternative_email_addresses ([AlternativeEmailAddressDto], none_type): [optional]  # noqa: E501
            custom_fields ([ContactCustomFieldValueSaveDto], none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """ContactSaveDto - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            primary_email_address (str, none_type): [optional]  # noqa: E501
            full_name (str, none_type): [optional]  # noqa: E501
            notes (str, none_type): [optional]  # noqa: E501
            linked_in_profile (str, none_type): [optional]  # noqa: E501
            person_symbol (str, none_type): [optional]  # noqa: E501
            role_id (str): [optional]  # noqa: E501
            type_id (str): [optional]  # noqa: E501
            address (ContactAddressDto): [optional]  # noqa: E501
            phone_numbers ([ContactPhoneSaveDto], none_type): [optional]  # noqa: E501
            left_relationships ([ContactRelationshipSaveDto], none_type): [optional]  # noqa: E501
            right_relationships ([ContactRelationshipSaveDto], none_type): [optional]  # noqa: E501
            alternative_email_addresses ([AlternativeEmailAddressDto], none_type): [optional]  # noqa: E501
            custom_fields ([ContactCustomFieldValueSaveDto], none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
